THE THINC BUFFERING MANIFESTO

-> uses same data structures as offscreen pixmaps
-> when something happens on screen, instead of calling SendBlahBlehBlih()
we buffer the message. for the offscreen case this is simple, just copy
the cmd from the pixmap's queue to all the clients' queue. For onscreen,
we need to create the commands on the fly (similar to QueueCommand() for
offscreen)
-> on BlockHandler() we flush as much of the clients' buffer as possible.
Note that to maintain good packet size and allow additional processing
of the output data, flushing the buffer entails serializing the commands
into a single stream of data (with a possible maximum size) which then
gets passed to Flush(). [ In the future, an encryption module may be added
between these two] 
-> We need a mechanism to serialize just enough data that we know
we can write out. Remember that serializing is the point of no return,
so it's bad to have any outstanding data in this stage. Idea would be
to serialize in limited size chunks. However, if the update is too big,
what can we do?? break it up?? [may hurt client's performance] Although
compressed updates may help with reducing the size of updates.
-> How are commands stored in the queue? They should be as ready to sent
as possible while still allowing further modification (in case they are
partially overwritten by new commands). In particular:
=> raw updates shouldn't be compressed. Moreover their actual data shouldn't
be stored in the queue (this may hurt performance if we're getting data
from a real framebuffer but the costs of storing raw data are 
prohibitive)
=> glyphs and bilevels should have their bitmaps stored, because
creating the bitmap on the fly may be expensive (and we'd need to do it
for every client). In addition, the bitmap may not have the same info
depending on when it's created.
=> pixmap fills should store the pixmap with the command.
-> When a command needs to be buffered do:

[ create cmd struct ] -> [ does it overwrite anything? ] -> yes -> [ modify
                                        |                             cmds ]
                                        v                               |
                                        no-----------> [ can merge? ] <--
                                                           /  \
                                                     yes  /    \ no
                                                         /      \
                                                        V        V
                                                    [ merge ]  [ add new cmd ]
						    
-> need to make the serialization process as simple as possible and as
transparent to the cmd-specific functions as possible. Current approach is
hackish and error-prone. And it has too many cases. If buffering is disabled,
the functions shouldn't need to worry about this. We should be able to 
convert things back to normal transparently. IDEA: If buffering is disabled,
functions will still call Buffer(), but all this does is call the
serializing functions (Execute()?) directly. Current buffering option
changes its meaning from "do good packet utilization" to "do actual
buffering". Good packet utilization is guaranteed by the serialization
process and cannot be disabled.
-> Can we create a stream approach (like zlib?) to serialize the data?
The functions would:
=> ask for space
=> if accepted, push data into the stream.
=> tell stream manager we're finished.
This shouldn't require any unnecessary copies (don't do something like
create the stream offline then memcpy to the real stream)
