/**************************************************************************
 *
 * Copyright 2002-2006 Columbia University
 * All Rights Reserved
 *
 **************************************************************************/
/* 
 * THINC Extension header - protocol function definition
 *
 * Authors: 
 * Ricardo A. Baratto - Network Computing Lab - Columbia University
 */

/* set tabstop 8 */

#ifndef _XTHINC_H_
#define _XTHINC_H_

#include <X11/extensions/xthincstr.h>

_XFUNCPROTOBEGIN

Bool XTHINCQueryExtension(Display *dpy);
Bool XTHINCQueryVersion(Display *dpy, int *major_version_return,
	int *minor_version_return);
Status XTHINCSetValue(Display *dpy, int which, int value);
/* for some of the values you need to first allocate a 'slot' for the server
 * to keep track of your own values. you'll have to pass id_return when
 * calling GetValue */
Status XTHINCGetID(Display *dpy, int *id_return);
Status XTHINCGetValue(Display *dpy, int id, int which, int *value_return);
Status XTHINCResetValue(Display *dpy, int id, int which);
/* these functions allow you to do get/reset of a bunch of values at once. vals
 * is an array of {which, value} structs, which has count elements. */
Status XTHINCGetValueBatch(Display *dpy, int id, xTHINC_batchGet* vals, 
	int count);
Status XTHINCResetValueBatch(Display *dpy, int id, int* vals, int count);
Bool XTHINCStatsFlush(Display *dpy);
Bool XTHINCStatsReset(Display *dpy);
Bool XTHINCInstrFlush(Display *dpy);
Bool XTHINCInstrReset(Display *dpy);
/* for application sharing */
Bool XTHINCWindowShare(Display *dpy, Window w);

_XFUNCPROTOEND

#endif /* _XTHINC_H_ */
