/* Copyright 2005, 2006, 2007 Ricardo Baratto */
/* Copyright 2005, 2006, 2007 Columbia University */
/*
 * Header for application sharing
 *
 * Authors: 
 * Ricardo A. Baratto - Network Computing Lab - Columbia University
 */

/* set tabstop = 8 */
#ifndef _THINC_APPSHARE_H_

#ifdef T_APPSHARE

typedef struct thincApp_S {
	unsigned int 	id;
	thincListRec	windows; /* list of windows belonging to this
				    app */
	unsigned int 	flags:16;
	unsigned int 	count:16; /* to satisfy our curiosity */
	unsigned int	name_len:8;
	char		*name;
} thincAppRec, *thincAppPtr;

/* app 0 is the X server (root window) */
#define t_app_id(id)	CLIENT_ID(id)	/* resource.h */
#define T_APP_MAX	MAXCLIENTS

/* get the app id of a window */
#define t_window_app(pWindow) t_app_id((pWindow)->drawable.id)

/* flags */
#define T_APP_ACTIVE	0x0001
#define T_APP_SHARED	0x0002

int thincAppshareInit(thincScreenPtr pThinc);
void thincAppshareUninit(thincScreenPtr pThinc);

int thincAppWindowAdd(WindowPtr pWindow);
void thincAppWindowRemove(WindowPtr pWindow);

int thincWindowShare(thincScreenPtr pThinc, WindowPtr pWin);
int thincWindowIsShared(thincScreenPtr pThinc, WindowPtr pWin);
int thincWindowUnshare(thincScreenPtr pThinc, WindowPtr pWin);

#if 0
int thincWindowShareSimple(thincScreenPtr pThinc, WindowPtr pWin);
int thincWindowShareAll(thincScreenPtr pThinc, WindowPtr pWin);
#endif
#else
/* noop */
#define thincAppshareInit(pThinc)		T_OK
#define thincAppshareUninit(pThinc)
#define thincWindowShare(pThinc, pWin)		T_OK
#define thincWindowIsShared(pWin)		T_OK
#define thincWindowShareSimple(pThinc, pWin) 	T_OK
#define thincWindowShareAll(pThinc, pWin)	T_OK

#endif /* T_APPSHARE */

#endif /* _THINC_APPSHARE_H_ */
