/* Copyright 2005, 2006, 2007 Ricardo Baratto */
/* Copyright 2005, 2006, 2007 Columbia University */
/* 
 * RENDER code functions and definitions
 *
 * Authors: 
 * Ricardo A. Baratto - Network Computing Lab - Columbia University
 */

/* set tabstop 8 */

#ifndef _THINC_RENDER_H_
#define _THINC_RENDER_H_

#ifdef T_USERENDER

int thincPictureInit(ScreenPtr pScreen);
void thincPictureUninit(ScreenPtr pScreen);

int thincGetBitmapFromGlyph(thincScreenPtr pThinc, GlyphListPtr lists, 
	int nlists, GlyphPtr *glyphs, char **bitmap_p, 
	BoxPtr extents);

/* RENDER functions (thincRender.c) */
int thincCreatePicture 	(PicturePtr pPicture);
void thincDestroyPicture (PicturePtr pPicture);
int thincChangePictureClip (PicturePtr pPicture, int clipType, 
			pointer value, int n);
void thincDestroyPictureClip (PicturePtr pPicture);
void thincChangePicture	(PicturePtr pPicture, Mask mask);
void thincValidatePicture(PicturePtr pPicture, Mask mask);
Bool thincInitIndexed 	(ScreenPtr pScreen, PictFormatPtr pFormat);
void thincCloseIndexed 	(ScreenPtr pScreen, PictFormatPtr pFormat);
void thincUpdateIndexed (ScreenPtr pScreen, PictFormatPtr pFormat, 
			int ndef, xColorItem *pdef);

/* rendering functions */
void thincComposite	(CARD8 op, PicturePtr pSrc, PicturePtr pMask,
			PicturePtr pDst, INT16 xSrc, INT16 ySrc, 
			INT16 xMask, INT16 yMask, INT16 xDst, 
			INT16 yDst, CARD16 width, CARD16 height);
void thincGlyphs (CARD8 op, PicturePtr pSrc, PicturePtr pDst, 
			PictFormatPtr maskFormat, INT16 xSrc, 
			INT16 ySrc, int nlists, GlyphListPtr lists, 
			GlyphPtr *glyphs);
void thincCompositeRects (CARD8 op, PicturePtr pDst, xRenderColor *color,
			int nRect, xRectangle *rects);

void thincTrapezoids 	(CARD8 op, PicturePtr pSrc, PicturePtr pDst,
			PictFormatPtr maskFormat, INT16 xSrc, INT16 ySrc,
			int  ntrap, xTrapezoid *traps);

void thincTriangles 	(CARD8 op, PicturePtr pSrc, PicturePtr pDst,
			PictFormatPtr maskFormat, INT16 xSrc, INT16 ySrc,
			int ntri, xTriangle *tris);

void thincTriStrip	(CARD8 op, PicturePtr pSrc, PicturePtr pDst,
			PictFormatPtr maskFormat, INT16 xSrc, INT16 ySrc,
			int npoint, xPointFixed *points);

void thincTriFan	(CARD8 op, PicturePtr pSrc, PicturePtr pDst,
			PictFormatPtr maskFormat, INT16 xSrc, INT16 ySrc,
			int npoint, xPointFixed *points);
void thincRasterizeTrapezoid (PicturePtr	pMask, xTrapezoid *trap,
			int x_off, int y_off);

#endif /* T_USERENDER */
#endif /* _THINC_RENDER_H_ */
