#ifndef _THINCDEV_H_
#define _THINCDEV_H_

/* normal includes.. */

/*** xf86 common layer includes ***/
#include "xf86.h"
#include "xf86_OSproc.h"
#include "xf86_ansic.h"
#include "xf86Resources.h"
#include "xf86cmap.h"
#include "xf86_libc.h"

/*** mi layer includes ***/
#include "mipointer.h"
#include "micmap.h"

#include "fb.h"

/* system includes */
#include <stdarg.h>

/* uncomment to enable debugging */
#define THINCDEV_DEBUG

/* used for printing msgs */
#ifdef __GNUC__ /* make gcc check that messages to print are correct */
void thincdevDbg(const char *fmt, ...)
	__attribute__ ((format (__printf__, 1, 2)));
void thincdevError(int index, const char *fmt, ...)
	__attribute__ ((format (__printf__, 2, 3)));
void thincdevMsg(int index, const char *fmt, ...)
	__attribute__ ((format (__printf__, 2, 3)));
#else
void thincdevDbg(const char *fmt, ...);
void thincdevError(int index, const char *fmt, ...);
void thincdevMsg(int index, const char *fmt, ...);
#endif

#endif	/* end thincdev.h */
